//********************************************************************************************************************************
//*                                                                                                                              *
//*     Delphi Unicode MySQL ADO Tutorial for Beginners  3delite 2010                                                           *
//*                                                                                                                              *
//* Needs an installed MySQL Express server running. Recommended MySQL server is MS MySQL Express 2008.                          *
//* Compiling the source requires Delphi 2009 or above.                                                                          *
//*                                                                                                                              *
//*     http://www.3delite.hu/Object Pascal Developer Resources/delphiunicodemysqltutorial.html                                  *
//*                                                                                                                              *
//* If you have found this tutorial usefull and want to award the author please consider buying a registration for one of my     *
//* programs. See:                                                                                                               *
//*                                                                                                                              *
//*     http://www.3delite.hu                                                                                                    *
//*                                                                                                                              *
//* If you have any questions or enquiries please mail: 3delite@3delite.hu                                                       *
//*                                                                                                                              *
//* Good coding! :)                                                                                                              *
//* 3delite                                                                                                                      *
//********************************************************************************************************************************

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, ADODB, IBCustomDataSet,
  IBQuery, DBClient, Spin;

type
  TFormUnicodeMySQLTutorial = class(TForm)
    DBGrid1: TDBGrid;
    ButtonGetSelected: TButton;
    Memo1: TMemo;
    ButtonGetDataSet: TButton;
    ButtonCreateDatabase: TButton;
    ButtonAddRecord: TButton;
    EditFirstName: TEdit;
    EditLastName: TEdit;
    ADOQuery1: TADOQuery;
    ADOConnection1: TADOConnection;
    ButtonCreateTable: TButton;
    DataSource1: TDataSource;
    GroupBoxCreateDatabase: TGroupBox;
    GroupBoxCreateTable: TGroupBox;
    GroupBoxAddRecord: TGroupBox;
    EditDatabaseFilename: TEdit;
    Label1: TLabel;
    ButtonSelectDatabase: TButton;
    Label2: TLabel;
    EditDatabaseName: TEdit;
    Label3: TLabel;
    SpinEditDatabaseSize: TSpinEdit;
    EditTableName: TEdit;
    LabelTableName: TLabel;
    Edit1ColumnName: TEdit;
    Label1ColumnName: TLabel;
    Edit2ColumnName: TEdit;
    Label2ColumnName: TLabel;
    GroupBoxQueryDatabase: TGroupBox;
    LabelFirstName: TLabel;
    LabelLastName: TLabel;
    SaveDialog1: TSaveDialog;
    LabelCreateTableNote: TLabel;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Label4: TLabel;
    procedure ButtonGetSelectedClick(Sender: TObject);
    procedure ButtonGetDataSetClick(Sender: TObject);
    procedure ButtonCreateDatabaseClick(Sender: TObject);
    procedure ButtonAddRecordClick(Sender: TObject);
    procedure ButtonCreateTableClick(Sender: TObject);
    procedure ButtonSelectDatabaseClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ADOConnection1BeforeConnect(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormUnicodeMySQLTutorial: TFormUnicodeMySQLTutorial;

implementation

{$R *.dfm}

procedure TFormUnicodeMySQLTutorial.ButtonSelectDatabaseClick(Sender: TObject);
begin
    if SaveDialog1.Execute then begin
        EditDatabaseFilename.Text := SaveDialog1.FileName;
    end;
end;

procedure TFormUnicodeMySQLTutorial.FormDestroy(Sender: TObject);
begin
    ADOQuery1.Close;
end;

procedure TFormUnicodeMySQLTutorial.ButtonCreateDatabaseClick(Sender: TObject);
begin

    ADOQuery1.SQL.Clear;

    ADOQuery1.SQL.Add('CREATE DATABASE "' + EditDatabaseName.Text + '"');
    ADOQuery1.SQL.Add('ON');
    ADOQuery1.SQL.Add('(');
    ADOQuery1.SQL.Add('NAME = "' + EditDatabaseName.Text + '_dat",');
    ADOQuery1.SQL.Add('FILENAME = "' + EditDatabaseFilename.Text + '",');
    ADOQuery1.SQL.Add('SIZE = ' + IntToStr(SpinEditDatabaseSize.Value));
    ADOQuery1.SQL.Add(')');

    ADOQuery1.ExecSQL;

end;

procedure TFormUnicodeMySQLTutorial.ButtonCreateTableClick(Sender: TObject);
begin

    ADOQuery1.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery1.SQL.Add('USE ' + EditDatabaseName.Text + ';');
    //* Create a new table
    ADOQuery1.SQL.Add('CREATE TABLE "' + EditTableName.Text + '"');
    ADOQuery1.SQL.Add('(');
    //* On the form only 2 columns are specified but we create 4 columns
    //* Add a unique identifier named "Id" with auto-increment
    ADOQuery1.SQL.Add('Id INT IDENTITY(1,1) NOT NULL,');
    //* Add the 2 specified columns as unicode type, max. 50 characters
    ADOQuery1.SQL.Add(Edit1ColumnName.Text + ' NVARCHAR(50),');
    ADOQuery1.SQL.Add(Edit2ColumnName.Text + ' NVARCHAR(50),');
    //* Add a date & time column (type DATETIME)
    ADOQuery1.SQL.Add('Date DATETIME,');
    //* Id column as primary key
    ADOQuery1.SQL.Add('PRIMARY KEY (Id)');
    ADOQuery1.SQL.Add(')');

    ADOQuery1.ExecSql;

end;

procedure TFormUnicodeMySQLTutorial.ADOConnection1BeforeConnect(Sender: TObject);
begin
    ADOConnection1.ConnectionString := Edit1.Text;
end;

procedure TFormUnicodeMySQLTutorial.ButtonAddRecordClick(Sender: TObject);
begin

    ADOQuery1.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery1.SQL.Add('USE ' + EditDatabaseName.Text + ';');
    //* Insert a new record
    ADOQuery1.SQL.Add('INSERT INTO ' + EditTableName.Text);
    ADOQuery1.SQL.Add('(' + Edit1ColumnName.Text + ', ' + Edit2ColumnName.Text + ', Date) VALUES (:a, :b, :c)');
    //* Specify the values and their data type ftWideString = unicode
    ADOQuery1.Parameters.ParamByName('a').DataType := ftWideString;
    ADOQuery1.Parameters.ParamByName('a').Value := EditFirstName.Text;
    ADOQuery1.Parameters.ParamByName('b').DataType := ftWideString;
    ADOQuery1.Parameters.ParamByName('b').Value := EditLastName.Text;
    ADOQuery1.Parameters.ParamByName('c').DataType := ftDateTime;
    ADOQuery1.Parameters.ParamByName('c').Value := Now;

    ADOQuery1.ExecSQL;

end;


procedure TFormUnicodeMySQLTutorial.ButtonGetSelectedClick(Sender: TObject);
var
  Buffer: Pointer;
  St: TStream;
  i, j: Integer;
  s: string;
begin

    //* Get the current record and display it in a TMemo
    s := '';
    s := DataSource1.DataSet.FieldByName('Id').AsWideString;
    s := s + ',' + DataSource1.DataSet.FieldByName(Edit1ColumnName.Text).AsWideString;
    s := s + ',' + DataSource1.DataSet.FieldByName(Edit2ColumnName.Text).AsWideString;
    s := s + ',' + DataSource1.DataSet.FieldByName('Date').AsWideString;
    DataSource1.DataSet.Next;
    Memo1.Lines.Append(s);

    //* Some usefull code to get data streams
    {
    GetMem(Buffer, DataSource1.DataSet.FieldByName('FirstName').DataSize);
    DataSource1.DataSet.FieldByName('FirstName').GetData(Buffer);
    St := TMemoryStream.Create;
    St.Write(Buffer, DataSource1.DataSet.FieldByName('FirstName').DataSize);
    Showmessage(IntToStr(St.Size));
    St.Seek(0, soFromBeginning);
    Memo1.Lines.LoadFromStream(St);
    St.Free;
    }
    //* Code to get all the fields
    {
    for j := 0 to DataSource1.DataSet.FieldCount-1 do
    begin
      if (j>0) then s:=s+', ';
      s:=s+DataSource1.DataSet.Fields[j].AsString;
    end;
    Memo1.Lines.Add(s);
    }
end;

procedure TFormUnicodeMySQLTutorial.ButtonGetDataSetClick(Sender: TObject);
var
  s: string;
begin

    ADOQuery1.Close;
    ADOQuery1.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery1.SQL.Add('USE ' + EditDatabaseName.Text + ';');
    //* Get all data
    ADOQuery1.SQL.Add('SELECT * FROM ' + EditTableName.Text);
    ADOQuery1.Open;

    //* This is how to get all the data resulted from the query and display it in a TMemo
    Memo1.Clear;

    DataSource1.DataSet.First;
    while NOT DataSource1.DataSet.Eof do begin
        s := '';
        s := DataSource1.DataSet.FieldByName('Id').AsWideString;
        s := s + ',' + DataSource1.DataSet.FieldByName(Edit1ColumnName.Text).AsWideString;
        s := s + ',' + DataSource1.DataSet.FieldByName(Edit2ColumnName.Text).AsWideString;
        s := s + ',' + DataSource1.DataSet.FieldByName('Date').AsWideString;
        DataSource1.DataSet.Next;
        Memo1.Lines.Append(s);
    end;

end;

end.
